/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.gui;

import java.util.ArrayList;
import java.util.Arrays;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import org.visnow.vn.engine.core.ParameterProxy;
import static org.visnow.vn.lib.gui.DownsizeUIShared.*;

/**
 *
 * @author Krzysztof S. Nowinski, University of Warsaw, ICM
 * <p>
 * Modified by Szymon Jaranowski (s.jaranowski@icm.edu.pl), University of Warsaw,
 * Interdisciplinary Centre for Mathematical and Computational Modelling,
 * since revision 660.
 * <p>
 * Modified by Szpak.
 * Model is partly kept in spinners now! Setters do not fire an action.
 * Added {@link ParameterProxy} and {@link #updateGUI(org.visnow.vn.engine.core.ParameterProxy)} support.
 */
public class DownsizeUI extends javax.swing.JPanel
{
    private boolean dynamicButtonPresent = true;
    private int[] defaultDownsize
            = {
                3, 3, 3
            };
    private boolean active = true;

    ParameterProxy parameterProxy;

    /**
     * Creates new form DownsizeUI
     */
    public DownsizeUI()
    {
        initComponents();
    }

    public void setParameterProxy(ParameterProxy parameterProxy)
    {
        this.parameterProxy = parameterProxy;
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        iLabel = new javax.swing.JLabel();
        iSpinner = new javax.swing.JSpinner();
        jLabel = new javax.swing.JLabel();
        jSpinner = new javax.swing.JSpinner();
        kLabel = new javax.swing.JLabel();
        kSpinner = new javax.swing.JSpinner();
        buttonsPanel = new javax.swing.JPanel();
        autoBox = new javax.swing.JToggleButton();
        noDownButton = new javax.swing.JButton();
        defaultButton = new javax.swing.JButton();

        setBorder(javax.swing.BorderFactory.createTitledBorder("Downsize"));
        setLayout(new java.awt.GridBagLayout());

        iLabel.setText("I:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(0, 7, 0, 5);
        add(iLabel, gridBagConstraints);

        iSpinner.setModel(new javax.swing.SpinnerNumberModel(Integer.valueOf(3), Integer.valueOf(1), null, Integer.valueOf(1)));
        iSpinner.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                iSpinnerStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(iSpinner, gridBagConstraints);

        jLabel.setText("J:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(0, 7, 0, 5);
        add(jLabel, gridBagConstraints);

        jSpinner.setModel(new javax.swing.SpinnerNumberModel(Integer.valueOf(3), Integer.valueOf(1), null, Integer.valueOf(1)));
        jSpinner.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                jSpinnerStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(jSpinner, gridBagConstraints);

        kLabel.setText("K:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(0, 7, 0, 5);
        add(kLabel, gridBagConstraints);

        kSpinner.setModel(new javax.swing.SpinnerNumberModel(Integer.valueOf(3), Integer.valueOf(1), null, Integer.valueOf(1)));
        kSpinner.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                kSpinnerStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 5);
        add(kSpinner, gridBagConstraints);

        buttonsPanel.setLayout(new java.awt.GridBagLayout());

        autoBox.setSelected(true);
        autoBox.setText("Dynamic");
        autoBox.setMargin(new java.awt.Insets(2, 2, 2, 2));
        autoBox.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                autoBoxActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        buttonsPanel.add(autoBox, gridBagConstraints);

        noDownButton.setText("No down");
        noDownButton.setMargin(new java.awt.Insets(2, 2, 2, 2));
        noDownButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                noDownButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        buttonsPanel.add(noDownButton, gridBagConstraints);

        defaultButton.setText("Default");
        defaultButton.setMargin(new java.awt.Insets(2, 2, 2, 2));
        defaultButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                defaultButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        buttonsPanel.add(defaultButton, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(buttonsPanel, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void iSpinnerStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_iSpinnerStateChanged
    {//GEN-HEADEREND:event_iSpinnerStateChanged
        if (!autoBox.isVisible() || autoBox.isSelected())
            fireStateChangedIfActive();
    }//GEN-LAST:event_iSpinnerStateChanged

    private void jSpinnerStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_jSpinnerStateChanged
    {//GEN-HEADEREND:event_jSpinnerStateChanged
        if (!autoBox.isVisible() || autoBox.isSelected())
            fireStateChangedIfActive();
    }//GEN-LAST:event_jSpinnerStateChanged

    private void kSpinnerStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_kSpinnerStateChanged
    {//GEN-HEADEREND:event_kSpinnerStateChanged
        if (!autoBox.isVisible() || autoBox.isSelected())
            fireStateChangedIfActive();
    }//GEN-LAST:event_kSpinnerStateChanged

    private void noDownButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_noDownButtonActionPerformed
    {//GEN-HEADEREND:event_noDownButtonActionPerformed
        updateSpinners(Arrays.copyOf(new int[]{1, 1, 1}, defaultDownsize.length));
        fireStateChangedIfActive();
    }//GEN-LAST:event_noDownButtonActionPerformed

    private void autoBoxActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_autoBoxActionPerformed
    {//GEN-HEADEREND:event_autoBoxActionPerformed
        if (autoBox.isSelected() && active)
            fireStateChangedIfActive();
    }//GEN-LAST:event_autoBoxActionPerformed

    private void defaultButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_defaultButtonActionPerformed
    {//GEN-HEADEREND:event_defaultButtonActionPerformed
        updateSpinners(defaultDownsize);
        fireStateChangedIfActive();
    }//GEN-LAST:event_defaultButtonActionPerformed

    public int[] getDownsize()
    {
        return Arrays.copyOf(new int[]{(Integer) iSpinner.getValue(), (Integer) jSpinner.getValue(), (Integer) kSpinner.getValue()}, defaultDownsize.length);
    }

    private void updateSpinners(int[] downsize)
    {
        active = false;

        iSpinner.setValue(downsize[0]);
        if (downsize.length > 1)
            jSpinner.setValue(downsize[1]);
        if (downsize.length > 2)
            kSpinner.setValue(downsize[2]);

        jSpinner.setEnabled(downsize.length > 1);
        jLabel.setEnabled(downsize.length > 1);

        kSpinner.setEnabled(downsize.length > 2);
        kLabel.setEnabled(downsize.length > 2);

        active = true;
    }

    public void setDownsize(int[] currentAndDefaultDownsize)
    {
        defaultDownsize = new int[currentAndDefaultDownsize.length];
        System.arraycopy(currentAndDefaultDownsize, 0, defaultDownsize, 0, currentAndDefaultDownsize.length);
        updateSpinners(currentAndDefaultDownsize);
    }

    public void setDownsize(int[] downsize, int[] defaultDownsize)
    {
        if (downsize.length != defaultDownsize.length)
            throw new IllegalArgumentException("Current and default downsize dimensions don't match: " + downsize.length + " " + defaultDownsize.length);
        this.defaultDownsize = new int[defaultDownsize.length];
        System.arraycopy(defaultDownsize, 0, this.defaultDownsize, 0, downsize.length);
        updateSpinners(downsize);
    }

    public void setDynamicButtonVisible(boolean setVisible)
    {
        dynamicButtonPresent = setVisible;
        autoBox.setVisible(dynamicButtonPresent);
    }

    /**
     * Utility field holding list of ChangeListeners.
     */
    private transient ArrayList<ChangeListener> changeListenerList = new ArrayList<>();

    /**
     * Registers ChangeListener to receive events.
     *
     * @param listener The listener to register.
     */
    public synchronized void addChangeListener(ChangeListener listener)
    {
        changeListenerList.add(listener);
    }

    /**
     * Removes ChangeListener from the list of listeners.
     *
     * @param listener The listener to remove.
     */
    public synchronized void removeChangeListener(ChangeListener listener)
    {
        changeListenerList.remove(listener);
    }

    /**
     * Notifies all registered listeners about the event.
     *
     * @param object Parameter #1 of the <CODE>ChangeEvent<CODE> constructor.
     */
    private void fireStateChangedIfActive()
    {
        if (active) {
            ChangeEvent e = new ChangeEvent(this);
            for (ChangeListener listener : changeListenerList)
                listener.stateChanged(e);

            if (parameterProxy != null) parameterProxy.set(DOWNSIZE, getDownsize());
        }
    }

    public void updateGUI(ParameterProxy p)
    {
        setDownsize(p.get(DOWNSIZE), p.get(META_DEFAULT_DOWNSIZE));
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JToggleButton autoBox;
    private javax.swing.JPanel buttonsPanel;
    private javax.swing.JButton defaultButton;
    private javax.swing.JLabel iLabel;
    private javax.swing.JSpinner iSpinner;
    private javax.swing.JLabel jLabel;
    private javax.swing.JSpinner jSpinner;
    private javax.swing.JLabel kLabel;
    private javax.swing.JSpinner kSpinner;
    private javax.swing.JButton noDownButton;
    // End of variables declaration//GEN-END:variables

}
